/**
 * Settings style & layout
 * note: `lists.css' must be loaded before this stylesheet
 */

html, body {
  margin: 0;
  padding: 0;
  width: 100%;
  height: 100%;
  font-size: 10px;
  overflow: hidden;
}


/******************************************************************************
 * Setting panels: full-size <section role="region"> blocks
 */

/* Setting panels: full-size <section role="region"> blocks */
section[role="region"] {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  border: 0;
  overflow: hidden;
}

/**
 * Panel targets -- transitions
 * the `.previous', '.current' classes are set by settings.js
 */

/**
 * bug 976299 non-visible regions take an extra layer
 * in the layer tree. Remove them to improve scroll performance
 * in exchange for a reflow on section transitions.
 *
 * bug 976630 non-visible regions should have a visibility of hidden
 * for accessibility purposes. Removing the visibility transition
 * in hidden->visible avoids flashing.
 */
section[role="region"] {
  transform: translateX(+100%);
  visibility: hidden;
  height: 0;
}

section[role="region"].previous {
  transform: translateX(-100%);
  height: 100%;
}

section[role="region"].current {
  transform: translateX(0);
  visibility: visible;
  height: 100%;
}

/**
 * Only use the animation when ready
 */
body[data-ready="true"] section[role="region"] {
  transition: transform .4s ease, visibility .4s;
}

body[data-ready="true"] section[role="region"].current {
  transition: transform .4s ease;
}

/**
 * Headers should not scroll with the rest of the page, except for #root.
 */
section[role="region"] > header {
  position: absolute;
}

section[role="region"] > div {
  position: absolute;
  top: 5rem;
  right: 0;
  bottom: 0;
  left: 0;
  width: 100%;
  height: calc(100% - 5rem);
  overflow-y: scroll;
  will-change: scroll-position;
}

/*
 * Need this for scrollable background layer
 * optimization in gecko. See Bug 950250
 */
section[role="region"],
section[role="region"] > div > ul {
  background-color: #f4f4f4;
}

/******************************************************************************
 * Activities section = "root" and filtered by category
 */
#activityDoneButton {
  display: none;
}

body[data-filter-by] #activityDoneButton {
  display: block;
}

body[data-filter-by] #root > div header,
body[data-filter-by] #root > div li {
  display: none;
}

/* These rules show the "Network & Connectivity" header and items related to
   connectivity (airplane mode, Wi-Fi and cellular & data) */
body[data-filter-by="connectivity"] #root > div [data-category="connectivity"] {
  display: block;
}

/******************************************************************************
 * Explanation texts
 */

.explanation {
  padding: 0.5rem 3rem;
  font-style: italic;
  font-size: 1.4rem;
  color: #505859;
}

.description {
  font-size: 1.7rem;
  line-height: 2.3rem;
  white-space: normal;
  -moz-hyphens: auto;
}

.description p,
.description a,
.description label {
  font-size: 1.7rem;
  line-height: 2.3rem;
  white-space: normal;
}

.description label {
    padding: 0;
}

.description label span {
  height: auto;
  min-height: 6rem;
  padding-top: 1.2rem;
  padding-bottom: 1.2rem;
  font-size: 1.7rem;
  line-height: 2.3rem;
  white-space: normal;
}

.description small {
  font-size: 1.7rem;
  color: #505859;
}

.link-text {
  font-size: 1.4rem;
  color: #336699;
  text-decoration: underline;
}

.hint label span {
  top: 2.9rem !important;
}

.hint .explanation {
  font-style: normal;
  position: relative;
  margin-top: -2rem;
  padding: 0.5rem 4rem 1.3rem 1.5rem;
  white-space: normal;
}

.hint > label:not([for]) ~ .explanation {
  padding-right: 8rem;
}

.hint .explanation[hidden] {
  display: none;
}


/******************************************************************************
 * Wi-Fi settings
 */

/* three-state items: on|off|ready */

ul[data-state="off"] ~ *,
ul[data-state] li[data-state] {
  display: none;
}

ul[data-state="on"]    li[data-state="on"],
ul[data-state="off"]   li[data-state="off"],
ul[data-state="ready"] li[data-state="ready"] {
  display: block;
}

ul[data-state="ready"] li > a {
  padding-right: 6.2rem; /* 3rem (initial padding) + 3.2rem (wifi icon width) */
}

/**
 * Wi-Fi authentication fields:
 *   - hide password field on open networks
 *   - hide identifier field on non-EAP networks
 */

section li.password,
section li.password[hidden],
section li.eap,
section li.auth-phase2,
section li.server-certificate,
section li.server-certificate-description,
section li.identity {
  display: none;
}

section[data-security*="WEP"] li.password,
section[data-security*="WPA"] li.password,
section[data-security*="EAP"] li.eap,
section[data-security*="EAP"] li.auth-phase2,
section[data-security*="EAP"] li.server-certificate,
section[data-security*="EAP"] li.server-certificate-description,
section[data-security*="EAP"] li.identity {
  display: block;
}

section li.password {
  display: block; /*asf*/
  height: 12rem;
  padding-right: 0;
}

section li.password > label {
  position: absolute;
  top: 8.3rem;
  left: 0;
  right: 1.5rem;
  height: 3rem;
  z-index: 1;
}

section li.password > label > span:after {
  left: 0;
  right: auto;
  margin-left: 0;
}

section li.password > label > span {
  position: absolute;
  left: 1.5rem;
  padding-left: 3rem;
  height: 3rem;
  color: #848484;
  font-size: 1.7rem;
  line-height: 3rem;
}

section li.password > label:active > span {
  background-color: transparent;
  color: #848484;
}

section li.password > p {
  padding: 0.5rem 1.5rem 0;
  line-height: 3.3rem;
}

#pwd-auth {
  -moz-user-focus: ignore;
}

section ul.operate-certificate {
  position: fixed;
  bottom: 0;
  width: 100%;
  background: url(images/document_bg.png);
}

#wifi-certificate-files-List li.disabled a {
  opacity: 0.6;
  pointer-events: none;
}


/******************************************************************************
* Media Storage settings
*/

#mediaStorage .space-stackedbar {
  background-color: #E7E7E7;
  border: solid 0.1rem #A6A6A6;
  border-radius: 0.3rem;
  display: inline-block;
  height: 3rem;
  margin: 0.8rem 5%;
  padding: 0.1rem;
  width: 90%;
}

#mediaStorage .space-stackedbar .stackedbar-item {
  display: inline-block;
  height: 3rem;
}

#mediaStorage .space-stackedbar .color-music,
#mediaStorage .color-music .stackedbar-color-label {
  background-color: #82C72C;
}

#mediaStorage .space-stackedbar .color-pictures,
#mediaStorage .color-pictures .stackedbar-color-label {
  background-color: #00CAF2;
}

#mediaStorage .space-stackedbar .color-videos,
#mediaStorage .color-videos .stackedbar-color-label {
  background-color: #2295D3;
}

#mediaStorage .space-stackedbar .color-free,
#mediaStorage .color-free .stackedbar-color-label {
  background-color: #E7E7E7;
}

#mediaStorage .color-free .stackedbar-color-label {
  border: solid 0.1rem #A6A6A6;
}

#mediaStorage .color-music .stackedbar-color-label,
#mediaStorage .color-pictures .stackedbar-color-label,
#mediaStorage .color-videos .stackedbar-color-label,
#mediaStorage .color-free .stackedbar-color-label {
  border-radius: 0.3rem;
}

#mediaStorage .stackedbar-color-label {
  display: inline-block;
  height: 2rem;
  left: 1.5rem;
  padding: 0;
  position: absolute;
  top: 2.1rem;
  width: 2rem;
}

#mediaStorage .stackedbar-color-label + a {
  padding-left: 4rem;
}
/******************************************************************************
 * Call settings
 */

/* three-state items: on|off|unknown */
#menuItem-callWaiting .checkbox-label,
#menuItem-callWaiting[data-state="on"] .checkbox-label,
#menuItem-callWaiting[data-state="off"] .checkbox-label {
  display: block;
}

#menuItem-callWaiting .alert-label,
#menuItem-callWaiting[data-state="on"] .alert-label,
#menuItem-callWaiting[data-state="off"] .alert-label {
  display: none;
}

#menuItem-callWaiting[data-state="unknown"] .checkbox-label input ~ span:after {
  display: none;
}

#menuItem-callWaiting[data-state="unknown"] .alert-label {
  display: block;
}

#menuItem-callWaiting .alert-label > span {
  top: 50%;
  margin-top: -1.5rem;
}

#call .cw-alert .cw-alert-sub-p {
  border-top: none;
}

#call .cw-alert .cw-alert-checkbox-label {
  right: 0;
  height: 2.7rem;
  width: 100%;
}

#call li[aria-disabled="true"] .icon-dialog {
  opacity: 0.6;
  pointer-events: none;
}

/******************************************************************************
 * APN settings
 */

.apnSettings-custom {
  font-style: italic;
}

.apnSettings-advanced {
  padding-bottom: 1em;
}

/******************************************************************************
 * Internet sharing (Wi-Fi HotSpot)
 */

#hotspot ul li > a span {
  max-width: 50%;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

/******************************************************************************
 * Wallpaper snapshot
 */

#wallpaper-header { border: none; }

#wallpaper {
  position: relative;
  overflow: hidden;
  height: 17rem;
}

#wallpaper-button {
  background: url(images/wallpaper_edit.png) no-repeat 25rem 11.5rem / 4.5rem;
  position: absolute;
  border: none;
  height: 100%;
  width: 100%;
  top: 0;
  left: 0;
  margin: 0;
}
#wallpaper-button:active {
  background-image: url(images/wallpaper_edit_pressed.png);
}

#wallpaper-preview {
  margin-top: -10rem;
  position: absolute;
  width: 100%;
}

#screen-timeout {
  height: auto !important;
}

#display li {
  height: 6.2rem;
}
#display li:last-child {
  border-bottom: none;
}


/******************************************************************************
 * Volume & Brightness: min/max icons
 */

ul li > label.range-icons:before {
  content: '';
  position: absolute;
  top: calc(50% - 1.5rem);
  right: 0;
  bottom: 0;
  left: 0;
  margin: 0 auto;
  width: calc(100% - 2.3rem);
  height: 3rem;
  pointer-events: none;
}

ul li > label.range-icons.brightness:before {
  background:
    url(images/range_icons_brightness_min.png) no-repeat 0 50%,
    url(images/range_icons_brightness_max.png) no-repeat 100% 50%;
  background-size: 3rem;
  left: 1rem;
  right: auto;
}

#brightness-manual div {
  position: relative;
  top: calc(50% - 1.5rem);
  left: 5rem;
  height: 3rem;
  width: calc(100% - 10.7rem);
}

ul li > label.range-icons.volume:before {
  left: 1.4rem;
  right: auto;
  width: 3rem;
  top: 4.4rem;
}

ul li > label.range-icons.volume.media:before {
  background:
    url(images/sound_volume_media.png) no-repeat 0 50% / 3rem;
}

ul li > label.range-icons.volume.notification:before {
  background:
    url(images/sound_volume_ringer.png) no-repeat 0 50% / 3rem;
}

ul li > label.range-icons.volume.alarm:before {
  background:
    url(images/sound_volume_alarm.png) no-repeat 0 50% / 3rem;
}

ul li > label.range-icons.volume input {
  position: inherit;
  margin-left: 5.8rem;
  width: calc(100% - 7.5rem);
  opacity: 0;
  transition: opacity .6s ease 0s;
}

/******************************************************************************
 * SIM Toolkit
 */

#icc .hiddenheader {
  height: 0;
  padding: 0;
  background: none;
}

#icc .hidden {
  display: none;
}

/******************************************************************************
 * Date & Time
 */

#timezone-raw span,
#dateTime ul.disabled p,
#dateTime ul.disabled a {
  color: #797e80;
  opacity: 0.6;
  pointer-events: none;
}

#dateTime #timezone.disabled {
  display: none;
}

#time-manual span {
  pointer-events: none;
}

#time-manual input {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  opacity: 0;
}


/******************************************************************************
 * Improve Browser OS
 */
#improveBrowserOS-chooseFeedback li,
#improveBrowserOS-sendFeedback li {
  border: none;
}

#improveBrowserOS-sendFeedback li:first-child {
  min-height: 3rem;
}

#improveBrowserOS .link-text {
  white-space: nowrap;
}

#feedback-description {
  display: block;
  height: 10rem;
  padding: 1rem 1rem 1.2rem;
  resize: none;
}

#sendFeedback .pack-checkbox span {
  left: 3rem;
  right: auto;
  top: 2rem;
}

.feedback-choose-face {
  display: block;
  background: url(images/feedback_faces.png);
  width: 10rem;
  min-height: 10rem;
  background-repeat: no-repeat;
  background-color: transparent;
  background-size: 20rem;
}

#feedback-mood {
  text-align: center;
}

#feedback-mood li {
  display: inline-block;
  max-width: 11rem;
}

.feedback-face-caption {
  overflow: visible;
  white-space: normal;
  line-height: 2.6rem;
  padding-top: 1rem;
  min-height: 6rem;
  height: auto;
}

#feedback-happy {
  float: left;
}

#feedback-sad {
  float: right;
}

#feedback-happy .feedback-choose-face {
  display: inline-block;
  background-position: 0;
}

#feedback-sad .feedback-choose-face {
  display: inline-block;
  background-position: 100%;
}

.feedback-feel {
  text-align: center;
}

#feedback-email.hidden {
  display: none;
}

#feedback-send-btn {
  text-align: center;
}
/******************************************************************************
 * OS License
 */

#obtain-sc,
#os-license {
  width: 100%;
  height: calc(100% - 5rem);
}


/******************************************************************************
 * Help
 */

#call-support-link, #online-support-link {
  height: auto;
}

#help-call-support-numbers, #help-online-support-text {
  display: block;
  line-height: 3rem;
  margin-bottom: 2rem;
}

#help-call-support-numbers a, #help-online-support-text a {
  display: block;
}

#help[data-has-support-info] .no-support-info,
#help:not([data-has-support-info]) .support-info {
  display: none;
}

/******************************************************************************
 * Bluetooth
 */
#update-device-name > section input {
  margin: 1rem 0;
}

/* Web activity handling */
.skin-organic section[data-dialog] > header:first-child .icon.icon-back {
  background-image: url(/shared/style/headers/images/icons/organic/close.png);
}

section[data-dialog] > header:first-child .icon.icon-back {
  background-image: url(/shared/style/headers/images/icons/close.png);
}

/******************************************************************************
 * Firefox Accounts
 */

.fxa-logo {
  background-image: url('images/fxa_logo.png');
  background-repeat: no-repeat;
  background-size: 16.4rem;
  margin: 3rem auto 0;
  width: 17rem;
  height: 19.5rem;
}

#fxa-unverified .description {
  background-image: url('images/fxa_envelope.png');
  background-repeat: no-repeat;
  background-size: 7rem;
  background-position: 0 1.5rem;
  padding-top: 1.5rem;
}

#fxa-unverified .disabled {
  color: #ccc;
}

#fxa-unverified-text {
  padding-top: 0.8rem;
  margin-left: 6rem;
}

/******************************************************************************
* App Permissions
* 
* Note: The reason why we need this style is because element.hidden will make
* the CSS specificity 0,0,1,0 (Yes, it is a pseudo class). And because our BB
* 's CSS specificity is much higher than this, we have to override it again
* to make sure it will display as hidden.
*/
.clear-bookmarks-app[hidden] {
  display: none;
}

/******************************************************************************
 * Toaster
 */
section[role="status"] {
  transition: opacity .6s ease 0s;
  opacity: 0;
}

section[role="status"].toast-visible {
  opacity: 1;
}

/******************************************************************************
 * Right-To-Left layout
 */

html[dir="rtl"] section[role="region"] {
  transform: translateX(-100%);
}

html[dir="rtl"] section[role="region"].previous  {
  transform: translateX(+100%);
}

html[dir="rtl"] section[role="region"].current {
  transform: translateX(0);
}

/* 'show password' checkboxes */
html[dir="rtl"] label[for^="pwd"] {
  padding-left: inherit;
  padding-right: 3rem;
}

/* Following RTL Tweaks */

html[dir="rtl"] .hint .explanation {
  padding-left: 4rem;
  padding-right: 1.5rem;
  white-space: normal;
}

html[dir="rtl"] .hint > label:not([for]) ~ .explanation {
  padding-left: 8rem;
  padding-right: 1.5rem;
}

html[dir="rtl"] ul[data-state="ready"] li > a {
  padding-left: 6.2rem; /* 3rem (initial padding) + 3.2rem (wifi icon width) */
  padding-right: 3rem;
}

html[dir="rtl"] section li.password {
  padding-left: 0;
}

html[dir="rtl"] section li.password > label {
  left: 1.5rem;
  right: 0;
}

html[dir="rtl"] section li.password > label > span:after {
  left: auto;
  right: 0;
  margin-left: auto;
  margin-right: 0;
}

html[dir="rtl"] section li.password > label > span {
  left: auto;
  right: 1.5rem;
  padding-right: 3rem;
}

html[dir="rtl"] #mediaStorage .stackedbar-color-label {
  left: auto;
  right: 1.5rem;
}

html[dir="rtl"] #mediaStorage .stackedbar-color-label + a {
  padding-left: 0;
  padding-right: 4rem;
}

html[dir="rtl"] #call .cw-alert .cw-alert-checkbox-label {
  left: 0;
  right: auto;
}

html[dir="rtl"] #wallpaper-button {
  left: auto;
  right: 0;
}

html[dir="rtl"] ul li > label.range-icons.brightness:before {
  background-position: 100% 50%, 0 50%;
  left: auto;
  right: 1rem;
}

html[dir="rtl"] #brightness-manual div {
  left: auto;
  right: 5rem;
}

html[dir="rtl"] #time-manual input {
  left: auto;
  right: 0;
}

html[dir="rtl"] #sendFeedback .pack-checkbox span {
  left: auto;
  right: 3rem;
}

html[dir="rtl"] #feedback-happy {
  float: right;
}

html[dir="rtl"] #feedback-sad {
  float: left;
}

html[dir="rtl"] ul li > label.range-icons.volume:before {
  left: auto;
  right: 1.4rem;
  background-position: 100% 50%;
}

html[dir="rtl"] ul li > label.range-icons.volume input {
  margin-right: 5.8rem;
}
